using GZip

mutable struct GZBufferedStream <: IO
    io::GZipStream
    buf::Vector{UInt8}
    len::Int
    ptr::Int

    function GZBufferedStream(io::GZipStream)
        buf = Array(UInt8, io.buf_size)

        len = ccall((:gzread, GZip._zlib), Int32,
            (Ptr{Cvoid}, Ptr{Cvoid}, UInt32), io.gz_file, buf, io.buf_size)

        new(io, buf, len, 1)
    end
end

Base.close(io::GZBufferedStream) = close(io.io)

@inline function Base.read(io::GZBufferedStream, ::Type{UInt8})
    c = io.buf[io.ptr]
    io.ptr += 1

    if io.ptr == io.len+1 #No more data
        io.len = ccall((:gzread, GZip._zlib), Int32,
            (Ptr{Cvoid}, Ptr{Cvoid}, UInt32), io.io.gz_file, io.buf, io.io.buf_size)
        io.ptr = 1
    end
    c
end

@inline Base.eof(io::GZBufferedStream) = io.len == 0

#function bench()
    #io = GZBufferedStream(GZip.open("random.gz", "rb"))

    #thischar = 0x00
    #n = 0
    #while !eof(io)
        #thischar = read(io, UInt8)
        #n += 1
    #end
    #close(io)

    #println(n)
    #thischar
#end


#bench()

##random contains 10^8 rand(UInt8)s
#@time run(`gunzip -k -f random.gz`) #255 ms
#@time bench() #168 ms

import BufferedStreams, Zlib, GZip, Libz
include("gzbufferedstream.jl")

# Source:
# ftp://ftp.ensembl.org/pub/release-81/fasta/homo_sapiens/cds/Homo_sapiens.GRCh38.cds.all.fa.gz
const filename = "Homo_sapiens.GRCh38.cds.all.fa"
const gzfilename = "Homo_sapiens.GRCh38.cds.all.fa.gz"


const methods = [
    ("IOStream",                      () -> open(filename)),
    ("BufferedInputStream/IOStream",  () -> BufferedStreams.BufferedInputStream(open(filename))),
    ("BufferedInputStream/Mmap",      () -> BufferedStreams.BufferedInputStream(
                                                Mmap.mmap(open(filename), Vector{UInt8}, (filesize(filename),)))),
    ("IOBuffer/Mmap",                 () -> IOBuffer(Mmap.mmap(open(filename), Vector{UInt8}, (filesize(filename),)))),
    ("GZip",                          () -> GZip.gzopen(gzfilename)),
    ("Zlib",                          () -> Zlib.Reader(open(gzfilename))),
    ("Libz",                          () -> Libz.ZlibInflateInputStream(open(gzfilename))),
    ("Libz/Mmap",                     () -> Libz.ZlibInflateInputStream(
                                                 Mmap.mmap(open(gzfilename), Vector{UInt8}, (filesize(gzfilename),)))),
    ("GZBufferedStream",              () -> GZBufferedStream(gzopen(gzfilename))),
    ("Pipe/gzip",                     () -> open(`gzip -cd $gzfilename`)[1]),
    #("BufferedInputStream/Pipe/gzip", () -> BufferedStreams.BufferedInputStream(open(`gzip -cd $gzfilename`)[1])),
]


function bench(f)
    for (method_name, open_func) in methods
        print("  ", method_name, ":  ")
        f(open_func())
        println(round(f(open_func()), 4))
    end
end


function bench_readbytes(input)
    tic()
    readbytes(input)
    return toq()
end


function bench_read(input)
    tic()
    while !eof(input)
        read(input, UInt8)
    end
    return toq()
end


function bench_readline(input)
    tic()
    for line in eachline(input)
    end
    return toq()
end


println("readbytes")
bench(bench_readbytes)

println("read")
bench(bench_read)

println("readline")
bench(bench_readline)

import BufferedStreams, Zlib, GZip, Libz

# Source:
# ftp://ftp.ensembl.org/pub/release-81/fasta/homo_sapiens/cds/Homo_sapiens.GRCh38.cds.all.fa.gz
const filename = "Homo_sapiens.GRCh38.cds.all.fa"

# this just tests overhead, but IOStream has an advantage since knows it's a
# nop.
#const output_filename = "/dev/null"
const output_filename = "out.tmp"

const data = readall(open(filename))

const methods = [
    ("IOStream",                      () -> open(output_filename, "w")),
    ("BufferedOutputStream/IOStream", () -> BufferedStreams.BufferedOutputStream(open(output_filename, "w"))),
    ("BufferedOutputStream",          () -> BufferedStreams.BufferedOutputStream()),
    ("IOBuffer",                      () -> IOBuffer()),
    ("GZip",                          () -> GZip.gzopen(output_filename, "w")),
    ("Zlib",                          () -> Zlib.Writer(open(output_filename, "w"))),
    ("Libz",                          () -> Libz.ZlibDeflateOutputStream(open(output_filename, "w"))),
]


function bench(f)
    for (method_name, open_func) in methods
        print("  ", method_name, ":  ")
        f(open_func())
        println(round(f(open_func()), 4))
    end
end


function bench_write(output)
    tic()
    for c in data
        write(output, c)
    end
    close(output)
    return toq()
end


function bench_write_array(output)
    tic()
    write(output, data)
    close(output)
    return toq()
end


println("write")
bench(bench_write)

println("write array")
bench(bench_write_array)

"""
`BufferedOutputStream{T}` provides buffered writing to a sink of type `T`.

Any type `T` wrapped in a `BufferedOutputStream` must implement:

    BufferedStreams.writebytes(sink::T, buffer::Vector{UInt8}, n::Int, eof::Bool)

This function should:

* write `n` bytes from `buffer`, starting at the first position
* `eof` is `true` when there will be no more write operations to `sink`, to
  facilitate flushing or closing the sink, etc.
* `writebytes` should return the number of bytes written. This must be
  `n` or 0. A return value of 0 indicates data should not be evicted from
  the buffer.

The buffer passed to this function never reallocated by `BufferedOutputStream`,
so it's safe to retain a reference to it to, for example, report some bytes as
written but do so lazily or asynchronously.
"""
mutable struct BufferedOutputStream{T} <: IO
    sink::T
    buffer::Vector{UInt8}

    # Position of the next unused byte in buffer;
    # `position ≤ 0` indicates that the stream is closed.
    position::Int
end

function BufferedOutputStream(sink::T, bufsize::Integer=default_buffer_size) where T
    if bufsize ≤ 0
        throw(ArgumentError("buffer size must be positive"))
    end
    return BufferedOutputStream{T}(sink, Vector{UInt8}(undef, bufsize), 1)
end

function Base.show(io::IO, stream::BufferedOutputStream{T}) where T
    bufsize = length(stream.buffer)
    filled = stream.position
    if isopen(stream)
        print(io,
            summary(stream), "(<",
            _datasize(bufsize), " buffer, ",
            round(Int, filled / bufsize * 100), "% filled>)")
    else
        print(io, summary(stream), "(<closed>)")
    end
end

"""
Flush all accumulated data from the buffer.
"""
function flushbuffer!(stream::BufferedOutputStream, eof::Bool = false)
    buffered = stream.position - 1
    written = writebytes(stream.sink, stream.buffer, buffered, eof)
    if written != buffered
        error("BufferedOutputStream sink failed to write all data")
    end
    stream.position = 1
    return
end

function checkopen(stream::BufferedOutputStream)
    if !isopen(stream)
        error("buffered output stream is already closed")
    end
end

@inline function Base.write(stream::BufferedOutputStream, b::UInt8)
    checkopen(stream)
    position = stream.position
    buffer = stream.buffer
    if position > length(buffer)
        flushbuffer!(stream)
        position = stream.position
        buffer = stream.buffer
        if position > length(buffer)
            throw(EOFError)
        end
    end
    @inbounds buffer[position] = b
    stream.position = position + 1
    return 1
end

function Base.write(stream::BufferedOutputStream, data::Vector{UInt8})
    checkopen(stream)
    # TODO: find a way to write large vectors directly to the sink bypassing the buffer
    #append!(stream, data, 1, length(data))
    n_avail = lastindex(stream.buffer) - stream.position + 1
    n = min(length(data), n_avail)
    copyto!(stream.buffer, stream.position, data, 1, n)
    stream.position += n
    written = n
    while written < length(data)
        flushbuffer!(stream)
        n_avail = lastindex(stream.buffer) - stream.position + 1
        @assert n_avail > 0
        n = min(lastindex(data) - written, n_avail)
        copyto!(stream.buffer, stream.position, data, written + 1, n)
        stream.position += n
        written += n
    end
    return written
end

# TODO: This is too slow. I think this pointer/pointer_to_array trick may
# allocate, so we should try to avoid it everywhere, but especially here.
"""
Write part of a byte array.
"""
function Base.append!(stream::BufferedOutputStream, data::Vector{UInt8},
                      start::Int, stop::Int)
    buffer = stream.buffer
    position = stream.position
    writelen = stop - start + 1
    buflen = length(buffer)
    while true
        if position > buflen
            stream.position = position
            flushbuffer!(stream)
            position = stream.position
            buffer = stream.buffer
            buflen = length(buffer)
        end

        num_chunk_bytes = min(stop - start + 1, buflen - position + 1)
        copyto!(buffer, position, data, start, num_chunk_bytes)
        start += num_chunk_bytes
        position += num_chunk_bytes
        if start > stop
            break
        end
    end
    stream.position = position
    return writelen
end

function Base.flush(stream::BufferedOutputStream)
    flushbuffer!(stream)
    if applicable(flush, stream.sink)
        flush(stream.sink)
    end
    return
end

function Base.isopen(stream::BufferedOutputStream)
    return stream.position > 0
end

function Base.close(stream::BufferedOutputStream)
    if !isopen(stream)
        return
    end
    flush(stream)
    if applicable(close, stream.sink)
        close(stream.sink)
    end
    empty!(stream.buffer)
    stream.position = 0
    return
end

function Base.eof(stream::BufferedOutputStream)
    return true
end

function Base.position(stream::BufferedOutputStream)
    return max(0, position(stream.sink) + stream.position - 1)
end

function Base.pointer(stream::BufferedOutputStream, index::Integer = 1)
    return pointer(stream.buffer, stream.position + index - 1)
end

function available_bytes(stream::BufferedOutputStream)
    return max(lastindex(stream.buffer) - stream.position + 1, 0)
end

"""
`BufferedInputStream{T}` provides buffered reading from a source of type `T`.

Any type `T` wrapped in a `BufferedInputStream` must implement:

    BufferedStreams.readbytes!(source::T, buffer::Vector{UInt8}, from::Int, to::Int)

This function should:

* refill `buffer` starting at `from` and not filling past `to`.
* return the number of bytes read.

Failure to read any new data into the buffer is interpreted as eof.
"""
mutable struct BufferedInputStream{T} <: IO
    source::T
    buffer::Vector{UInt8}

    # Position of the next byte to be read in buffer;
    # `position ≤ 0` indicates that the stream is closed.
    position::Int

    # Number of bytes available in buffer.
    # I.e. buffer[1:available] is valid data.
    available::Int

    # If positive, preserve and move buffer[anchor:available]
    # when refilling the buffer.
    anchor::Int

    # If `true`, buffered data `buffer[anchor:available]` is not shifted.
    immobilized::Bool
end

function BufferedInputStream(source::T, bufsize::Integer = default_buffer_size) where T
    if bufsize ≤ 0
        throw(ArgumentError("buffer size must be positive"))
    end
    return BufferedInputStream{T}(source, Vector{UInt8}(undef, bufsize), 1, 0, 0, false)
end

function Base.show(io::IO, stream::BufferedInputStream{T}) where T
    bufsize = length(stream.buffer)
    filled = stream.available - stream.position + 1
    if isopen(stream)
        print(io,
            summary(stream), "(<",
            _datasize(bufsize), " buffer, ",
            round(Int, filled / bufsize * 100), "% filled",
            stream.immobilized ? ", data immobilized" : "", ">)")
    else
        print(io, summary(stream), "(<closed>)")
    end
end

"""
Refill the buffer, optionally moving and retaining part of the data,
ensuring buffer space to read at least `minalloc` bytes.
"""
function fillbuffer!(stream::BufferedInputStream, minalloc::Int = 1)
    if eof(stream.source)
        return 0
    end

    shiftdata!(stream)
    margin = length(stream.buffer) - stream.available
    if margin < minalloc
        resize!(stream.buffer, length(stream.buffer) * 2 + minalloc-1)
    end

    nbytes = readbytes!(
        stream.source,
        stream.buffer,
        stream.available + 1,
        length(stream.buffer))
    stream.available += nbytes
    return nbytes
end

# Shift data to be kept.
function shiftdata!(stream::BufferedInputStream)
    if stream.immobilized
        return 0
    else
        if stream.anchor > 0
            @assert stream.position ≥ stream.anchor
            shift = stream.anchor - 1
            n = stream.available - shift
            n > 0 && copyto!(stream.buffer, 1, stream.buffer, stream.anchor, n)
            stream.anchor -= shift
        elseif stream.available - stream.position + 1 > 0
            shift = stream.position - 1
            n = stream.available - shift
            copyto!(stream.buffer, 1, stream.buffer, stream.position, n)
        else
            # no data to be kept
            @assert stream.position > stream.available
            shift = stream.available
        end
        stream.position -= shift
        stream.available -= shift
        return shift
    end
end

@inline function Base.eof(stream::BufferedInputStream)
    if stream.position > stream.available
        return fillbuffer!(stream) == 0
    else
        return false
    end
end

@inline function Base.bytesavailable(stream::BufferedInputStream)
    if eof(stream)
        return 0
    else
        return stream.available - stream.position + 1
    end
end

@inline function Base.readavailable(stream::BufferedInputStream)
    read(stream, bytesavailable(stream))
end

@inline function Base.skip(stream::BufferedInputStream, n_::Integer)
    n0 = n = convert(Int, n_)
    if n < 0
        throw(ArgumentError("n must be non-negative in skip(::BufferedInputStream, n)"))
    end

    while stream.position + n > stream.available + 1
        n -= stream.available - stream.position + 1
        stream.position = stream.available + 1
        if fillbuffer!(stream) < 1
            throw(EOFError())
        end
    end
    stream.position += n
    return n0
end

@inline function checkopen(stream::BufferedInputStream)
    if !isopen(stream)
        error("buffered input stream is already closed")
    end
end

"""
Return the next byte from the input stream without advancing the position.
"""
@inline function Base.peek(stream::BufferedInputStream)
    checkopen(stream)
    if stream.position > stream.available
        if fillbuffer!(stream) < 1
            throw(EOFError())
        end
    end
    @inbounds c = stream.buffer[stream.position]
    return c
end

"""
Fills `buffer` with bytes from `stream`'s buffer without advancing the
position.

Unless the buffer is empty, we do not re-fill it. Therefore the number of bytes
read is limited to the minimum of `nb` and the remaining bytes in the buffer.
"""
function peekbytes!(stream::BufferedInputStream,
                    buffer::AbstractArray{UInt8},
                    nb=length(buffer))
    checkopen(stream)
    if stream.position > stream.available
        if fillbuffer!(stream) < 1
            throw(EOFError())
        end
    end
    nb = min(nb, stream.available - stream.position + 1)
    copyto!(buffer, 1, stream.buffer, stream.position, nb)
    return nb
end

@inline function Base.read(stream::BufferedInputStream, ::Type{UInt8})
    checkopen(stream)
    if stream.position > stream.available
        if fillbuffer!(stream) < 1
            throw(EOFError())
        end
    end
    @inbounds c = stream.buffer[stream.position]
    stream.position += 1
    return c
end

# fast multi-byte data readers
for T in [Int16, UInt16, Int32, UInt32, Int64, UInt64, Int128, UInt128, Float16, Float32, Float64]
    @eval begin
        @inline function Base.read(stream::BufferedInputStream, ::Type{$(T)})
            checkopen(stream)
            if !ensurebuffered!(stream, $(sizeof(T)))
                throw(EOFError())
            end
            ptr::Ptr{$(T)} = pointer(stream)
            ret = unsafe_load(ptr)
            stream.position += $(sizeof(T))
            return ret
        end
    end
end

# fast char reader, split into lower-level routine for read(s, Char) + peek(s, Char) etc.
function _readchar(stream::BufferedInputStream)
    ensurebuffered!(stream, 4)
    p, avail = stream.position, stream.available
    p > avail && throw(EOFError())

    # code adapted from Base.read(io::IO, ::Type{Char}):
    @inbounds b0 = stream.buffer[p]
    p += 1
    l = 0x08 * (0x04 - (leading_ones(b0) % UInt8))
    c = UInt32(b0) << 24
    if l < 0x18
        s = 16
        while s ≥ l && p ≤ avail
            @inbounds b = stream.buffer[p]
            b & 0xc0 == 0x80 || break
            p += 1
            c |= UInt32(b) << s
            s -= 8
        end
    end
    return reinterpret(Char, c), p
end
function Base.read(stream::BufferedInputStream, ::Type{Char})
    checkopen(stream)
    c, stream.position = _readchar(stream)
    return c
end
function Base.peek(stream::BufferedInputStream, ::Type{Char})
    checkopen(stream)
    c, _ = _readchar(stream)
    return c
end
function Base.skipchars(predicate, stream::BufferedInputStream; linecomment=nothing)
    checkopen(stream)
    while !eof(stream)
        c, p = _readchar(stream)
        if c === linecomment
            stream.position = p # next Char
            while ensurebuffered!(stream, 1)
                @views lf = findnext(==(0x0a), stream.buffer[1:stream.available], stream.position)
                if isnothing(lf)
                    stream.position = stream.available + 1 # fill buffer again
                else
                    stream.position = lf + 1 # skip to next line
                    break
                end
            end
        elseif predicate(c)
            stream.position = p # skip to next Char
        else
            break
        end
    end
    return stream
end

if isdefined(Base, :unsafe_read)
    function Base.unsafe_read(stream::BufferedInputStream, ptr::Ptr{UInt8}, nb::UInt)
        p = ptr
        p_end = ptr + nb
        while p < p_end
            if ensurebuffered!(stream, 1)
                n = min(p_end - p, available_bytes(stream))
                ccall(:memcpy, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t), p, pointer(stream), n)
                p += n
                stream.position += n
            else
                throw(EOFError())
            end
        end
        return nothing
    end
end

# Special purpose readuntil for plain bytes.
function Base.readuntil(stream::BufferedInputStream, delim::UInt8)
    checkopen(stream)
    anchor!(stream)
    while true
        p0 = pointer(stream.buffer, stream.position)
        p1 = ccall(:memchr, Ptr{UInt8}, (Ptr{UInt8}, Cint, Csize_t),
                   p0, delim, stream.available - stream.position + 1)
        if p1 != C_NULL
            stream.position += p1 - p0
            break
        else
            stream.position = stream.available + 1
            nb = fillbuffer!(stream)
            if nb == 0
                chunk = takeanchored!(stream)
                return chunk
            end
        end
    end
    chunk = stream.buffer[upanchor!(stream):stream.position]
    stream.position += 1
    return chunk
end

function readbytes!(stream::BufferedInputStream,
                    buffer::AbstractArray{UInt8},
                    nb=length(buffer))
    return readbytes!(stream, buffer, 1, nb)
end

function readbytes!(stream::BufferedInputStream,
                    buffer::AbstractArray{UInt8},
                    from::Int, to::Int)
    p = from
    while !eof(stream) && p ≤ to
        @assert ensurebuffered!(stream, 1)
        n = min(to - p + 1, stream.available - stream.position + 1)
        copyto!(buffer, p, stream.buffer, stream.position, n)
        p += n
        stream.position += n
    end
    return p - from
end

function Base.ismarked(stream::BufferedInputStream)
    return stream.anchor > 0
end

function Base.mark(stream::BufferedInputStream)
    stream.anchor = stream.position
    return stream.anchor
end

function Base.unmark(stream::BufferedInputStream)
    if !ismarked(stream)
        return false
    end
    stream.anchor = 0
    return true
end

function Base.reset(stream::BufferedInputStream)
    if !ismarked(stream)
        error("buffered stream is not marked")
    end
    anchor = stream.anchor
    stream.position = anchor
    unmark(stream)
    return anchor
end

"""
Return true if the stream is anchored.
"""
function isanchored(stream::BufferedInputStream)
    return stream.anchor > 0
end

"""
Set the buffer's anchor to its current position.
"""
function anchor!(stream::BufferedInputStream)
    stream.anchor = stream.position
end

"""
Remove and return a buffer's anchor.
"""
function upanchor!(stream::BufferedInputStream)
    anchor = stream.anchor
    stream.anchor = 0
    return anchor
end

"""
Copy and return a byte array from the anchor up to, but not including the
current position, also removing the anchor.
"""
function takeanchored!(stream::BufferedInputStream)
    if stream.position - 1 > stream.available
        throw(EOFError())
    end
    chunk = stream.buffer[stream.anchor:stream.position - 1]
    upanchor!(stream)
    return chunk
end

function Base.position(stream::BufferedInputStream)
    return position(stream.source) - stream.available + stream.position - 1
end

function Base.seek(stream::BufferedInputStream{T}, pos::Integer) where T
    if applicable(seek, stream.source, pos)
        upanchor!(stream)
        source_position = position(stream.source)
        # is the new position within the buffer?
        if source_position - stream.available <= pos <= source_position
            stream.position = 1 + pos - (source_position - stream.available)
        else
            seek(stream.source, pos)
            stream.position = 1
            stream.available = 0
        end
    else
        throw(ArgumentError(
            string("Can't seek in input stream with source of type ", T)))
        # TODO: Allow seeking forwards by just reading and discarding input
    end
    return stream
end

function Base.isopen(stream::BufferedInputStream)
    return stream.position > 0
end

function Base.close(stream::BufferedInputStream)
    if !isopen(stream)
        return
    end
    if applicable(close, stream.source)
        close(stream.source)
    end
    stream.position = 0
    empty!(stream.buffer)
    return
end

function Base.pointer(stream::BufferedInputStream, index::Integer=1)
    return pointer(stream.buffer, stream.position + index - 1)
end

@inline function available_bytes(stream::BufferedInputStream)
    return stream.available - stream.position + 1
end

@inline function ensurebuffered!(stream::BufferedInputStream, nb::Integer)
    if available_bytes(stream) < nb
        fillbuffer!(stream, nb)
        if available_bytes(stream) < nb
            return false
        end
    end
    return true
end

if isdefined(Base, :copyuntil) # julia#48273 in Julia 1.11
    # optimized copyuntil using findnext on the buffer:
    function Base.copyuntil(out::IO, stream::BufferedInputStream, delim::UInt8; keep::Bool=false)
        checkopen(stream)
        @views @inbounds while ensurebuffered!(stream, 1)
            p = findnext(==(delim), stream.buffer[1:stream.available], stream.position)
            if isnothing(p)
                # delim not found, copy buffer & keep reading
                write(out, stream.buffer[stream.position:stream.available])
                stream.position = stream.available + 1
            else
                # delim found, copy buffer up to delim & stop
                oldp = stream.position
                stream.position = p + 1
                p -= !keep
                write(out, stream.buffer[oldp:p])
                break
            end
        end
        return out
    end

    # in principle, we could also similarly optimize Base.copyline,
    # but this is used mainly for readline, and there is already
    # an optimized copyline(out::IOBuffer, in::IO) method used there
    # that calls our optimized copyuntil above.
    #
    # For copyline(out::IO, in::IO), it only calls copyuntil for keep=false,
    # whereas the keep=true logic is more complicated to handle CRLF.
    # So in principle we could have a faster in::BufferedInputStream method
    # for this case, but I'm not sure how many people care.
end

using Documenter, BufferedStreams

makedocs(
    format = Documenter.HTML(
        prettyurls = !("local" in ARGS),
        canonical = "https://juliaio.net/BufferedStreams.jl/stable/",
    ),
    sitename = "BufferedStreams",
    pages = [
        "Home" => "index.md",
        "Input Streams" => "inputstreams.md",
        "Output Streams" => "outputstreams.md"
    ],
    authors = "D. C. Jones, Ben J. Ward"
)

deploydocs(
    repo = "github.com/JuliaIO/BufferedStreams.jl.git",
    target = "build",
)

using BufferedStreams
using Test, Random

Random.seed!(314159)

struct InfiniteStream <: IO
    byte::UInt8
end

function Base.eof(stream::InfiniteStream)
    return false
end

function Base.read(stream::InfiniteStream, ::Type{UInt8})
    return stream.byte
end

if isdefined(Base, :unsafe_read)
    function Base.unsafe_read(stream::InfiniteStream, pointer::Ptr{UInt8}, n::UInt)
        ccall(:memset, Cvoid, (Ptr{Cvoid}, Cint, Csize_t), pointer, stream.byte, n)
        return nothing
    end
end


# A few things that might not be obvious:
#   * In a few places we wrap an array in an IOBuffer before wrapping it in a
#     BufferedInputStream. This is to force the BufferedInputStream to read
#     incrementally to expose possible bugs in buffer refilling logic.
#   * Similar, we manually set the buffer size to be smaller than the default to
#     force more buffer refills.

# Uncommenting top-level testset makes the tests take ~100x longer
# @testset "BufferedInputStream" begin
    @testset "BufferedInputStream: read" begin
        data = rand(UInt8, 1000000)
        stream = BufferedInputStream(IOBuffer(data), 1024)
        read_data = UInt8[]
        while !eof(stream)
            push!(read_data, read(stream, UInt8))
        end
        @test data == read_data
        @test data == read(BufferedInputStream(IOBuffer(data), 1024))

        halfn = div(length(data), 2)
        @test data[1:halfn] == read(BufferedInputStream(IOBuffer(data), 1024), halfn)

        # read multi-byte data
        buffer = IOBuffer()
        write(buffer, UInt8(1))
        write(buffer, UInt16(2))
        write(buffer, UInt32(3))
        write(buffer, UInt64(4))
        write(buffer, UInt128(5))
        write(buffer, Float16(6))
        write(buffer, Float32(7))
        write(buffer, Float64(8))
        seekstart(buffer)
        stream = BufferedInputStream(buffer)
        @test read(stream, UInt8) === UInt8(1)
        @test read(stream, UInt16) === UInt16(2)
        @test read(stream, UInt32) === UInt32(3)
        @test read(stream, UInt64) === UInt64(4)
        @test read(stream, UInt128) === UInt128(5)
        @test read(stream, Float16) === Float16(6)
        @test read(stream, Float32) === Float32(7)
        @test read(stream, Float64) === Float64(8)

        # EOFError
        stream = BufferedInputStream(IOBuffer())
        @test_throws EOFError read(stream, UInt8)
        @test_throws EOFError read(stream, UInt16)
        @test_throws EOFError read(stream, UInt32)
        @test_throws EOFError read(stream, UInt64)
        @test_throws EOFError read(stream, UInt128)
        @test_throws EOFError read(stream, Float16)
        @test_throws EOFError read(stream, Float32)
        @test_throws EOFError read(stream, Float64)
    end

    if isdefined(Base, :unsafe_read)
        @testset "BufferedInputStream: unsafe_read" begin
            stream = BufferedInputStream(IOBuffer("abcdefg"), 3)
            data = Vector{UInt8}(undef, 7)
            unsafe_read(stream, pointer(data, 1), 1)
            @test data[1] == UInt8('a')
            unsafe_read(stream, pointer(data, 2), 2)
            unsafe_read(stream, pointer(data, 4), 4)
            @test data == b"abcdefg"
            @test_throws EOFError unsafe_read(stream, pointer(data), 1)
        end
    end

    @testset "BufferedInputStream: peek" begin
        stream = BufferedInputStream(IOBuffer([0x01, 0x02]))
        @test peek(stream) === 0x01
        @test peek(stream) === 0x01
        read(stream, UInt8)
        @test peek(stream) === 0x02
        @test peek(stream) === 0x02
    end

    @testset "BufferedInputStream: bytesavailable" begin
        stream = BufferedInputStream(IOBuffer([0x01, 0x02]))
        @test bytesavailable(stream) == 2
        read(stream, 1)
        @test bytesavailable(stream) == 1
        read(stream, 1)
        @test bytesavailable(stream) == 0
    end

    @testset "BufferedInputStream: peekbytes!" begin
        data = rand(UInt8, 1000000)
        stream = BufferedInputStream(IOBuffer(data), 1024)

        read_data = Array{UInt8}(undef, 1000)
        @test peekbytes!(stream, read_data, 1000) == 1000
        @test data[1:1000] == read_data
        # Check that we read the bytes we just peeked, i.e. that the position
        # wasn't advanced on peekbytes!()
        readbytes!(stream, read_data, 1000)
        @test data[1:1000] == read_data
        # Check that we now peek the next 24 bytes, as we don't go past the end
        # of the buffer
        @test peekbytes!(stream, read_data, 1000) == 24
        @test data[1001:1024] == read_data[1:24]

        # Reset the data
        data = rand(UInt8, 1000000)
        stream = BufferedInputStream(IOBuffer(data), 1024)

        read_data = Array{UInt8}(undef, 2000)
        @test peekbytes!(stream, read_data, 2000) == 1024
        # Note that we truncate at buffer size, as
        @test data[1:1024] == read_data[1:1024]

        # Check that we only read up to the buffer size
        read_data = Array{UInt8}(undef, 5)
        @test peekbytes!(stream, read_data) == 5
        @test data[1:5] == read_data

        close(stream)
        @test_throws Exception peekbytes!(stream, read_data)
    end

    @testset "BufferedInputStream: readbytes!" begin
        stream = BufferedInputStream(IOBuffer([0x01:0xff;]), 4)
        @test !eof(stream)
        out = zeros(UInt8, 2)
        @test BufferedStreams.readbytes!(stream, out) === 2
        @test out == [0x01, 0x02]
        out = zeros(UInt8, 3)
        @test BufferedStreams.readbytes!(stream, out) === 3
        @test out == [0x03, 0x04, 0x05]
        out = zeros(UInt8, 5)
        @test BufferedStreams.readbytes!(stream, out) === 5
        @test out == [0x06, 0x07, 0x08, 0x09, 0x0a]
        @test !eof(stream)
        @test read(stream) == [0x0b:0xff;]
        @test eof(stream)
    end

    @testset "BufferedInputStream: readuntil" begin
        data = rand(UInt8, 1000000)
        stream = BufferedInputStream(IOBuffer(data), 1024)

        true_num_zeros = 0
        zero_positions = Int[]
        for (i, b) in enumerate(data)
            if b == 0x00
                push!(zero_positions, i)
                true_num_zeros += 1
            end
        end

        num_zeros = 0
        chunk_results = Bool[]
        while true
            # are we extracting the right chunk?
            chunk = readuntil(stream, 0x00)
            first = num_zeros == 0 ? 1 : zero_positions[num_zeros]+1
            last = num_zeros < length(zero_positions) ?  zero_positions[num_zeros+1] : length(data)
            true_chunk = data[first:last]
            push!(chunk_results, true_chunk == chunk)

            if !eof(stream)
                num_zeros += 1
            else
                break
            end
        end

        @test all(chunk_results)
        @test num_zeros == true_num_zeros
    end

    @testset "BufferedInputStream: arrays" begin
        data = rand(UInt8, 1000000)
        stream = BufferedInputStream(data)
        read_data = UInt8[]
        while !eof(stream)
            push!(read_data, read(stream, UInt8))
        end
        @test data == read_data
        @test data == read(BufferedInputStream(data))
    end

    @testset "BufferedInputStream: marks" begin
        # very small buffer
        stream = BufferedInputStream(IOBuffer([0x01:0xff;]), 2)
        @test !ismarked(stream)
        mark(stream)
        @test ismarked(stream)
        a = read(stream, UInt8)
        b = read(stream, UInt8)
        c = read(stream, UInt8)
        reset(stream)
        @test !ismarked(stream)
        a′ = read(stream, UInt8)
        b′ = read(stream, UInt8)
        c′ = read(stream, UInt8)
        @test (a, b, c) == (a′, b′, c′) == (0x01, 0x02, 0x03)
        mark(stream)
        @test unmark(stream)
        @test !unmark(stream)
        @test_throws ErrorException reset(stream)
    end

    @testset "BufferedInputStream: anchors" begin
        data = rand(UInt8, 100000)

        function random_range(n)
            a = rand(1:n)
            b = rand(a:n)
            return a:b
        end

        # test that anchors work correctly by extracting random intervals from a
        # buffered stream.
        function test_anchor()
            r = random_range(length(data))
            i = 1
            stream = BufferedInputStream(IOBuffer(data), 1024)
            while !eof(stream)
                if i == r.start
                    anchor!(stream)
                end
                if i == r.stop + 1
                    return takeanchored!(stream) == data[r]
                end
                read(stream, UInt8)
                i += 1
            end
            if i == r.stop + 1
                return takeanchored!(stream) == data[r]
            end
            error("nothing extracted (range: $r)")
        end

        @test all(Bool[test_anchor() for _ in 1:100])

        # issue #78
        let io = BufferedInputStream(IOBuffer("α∆"), 1)
            @test read(io, Char) == 'α'
            mark(io)
            @test [read(io, UInt8) for _=1:3] == [0xe2, 0x88, 0x86]
            reset(io)
            @test read(io, Char) == '∆'
        end
    end

    @testset "BufferedInputStream: seek" begin
        n = 100000
        data = rand(UInt8, n)
        positions = rand(0:n-1, 1000)

        function test_seek(stream, p)
            seek(stream, p)
            return position(stream) == p && read(stream, UInt8) == data[p + 1]
        end

        stream = BufferedInputStream(data)
        @test all(Bool[test_seek(stream, p) for p in positions])

        stream = BufferedInputStream(IOBuffer(data), 1024)
        @test all(Bool[test_seek(stream, p) for p in positions])
        @test seekstart(stream) === stream
    end

    @testset "BufferedInputStream: skip" begin
        n = 100000
        data = rand(UInt8, n)
        positions = rand(0:n-1, 1000)
        sort!(positions)

        last = 1
        offsets = Int[]
        for p in positions
            push!(offsets, p - last)
            last = p
        end

        function test_skip(stream, p, offset)
            skip(stream, offset)
            peek(stream) == data[p]
        end

        stream = BufferedInputStream(IOBuffer(data), 1024)
        @test_throws Exception skip(stream, n + 1)
        @test_throws Exception skip(stream, -1)

        stream = BufferedInputStream(IOBuffer(data), 1024)
        @test all(Bool[test_skip(stream, p, offset)
                       for (p, offset) in zip(positions, offsets)])
    end

    @testset "BufferedInputStream: close" begin
        iobuffer = IOBuffer([0x00, 0x01])
        stream = BufferedInputStream(iobuffer)
        @test isopen(stream)
        @test isopen(iobuffer)
        read(stream, UInt8)
        @test close(stream) === nothing
        @test !isopen(stream)
        @test !isopen(iobuffer)
        @test_throws Exception read(stream, UInt8)
        @test close(stream) === nothing
    end

    @testset "BufferedInputStream: iostream" begin
        mktemp() do path, input
            write(input, [0x01, 0x02, 0x03, 0x04, 0x05])
            flush(input)
            seekstart(input)

            stream = BufferedInputStream(input, 2)
            @test !eof(stream)
            @test read(stream, UInt8) === 0x01
            @test !eof(stream)
            @test read(stream, UInt8) === 0x02
            @test !eof(stream)
            @test read(stream) == [0x03, 0x04, 0x05]
            @test eof(stream)

            @test isopen(stream)
            @test isopen(input)
            close(stream)
            @test !isopen(stream)
            @test !isopen(input)
        end
    end

    @testset "BufferedInputStream: immobilized buffer" begin
        stream = BufferedInputStream(IOBuffer("abcdefg"), 2)
        stream.immobilized = false
        @assert read(stream, UInt8) == UInt8('a')
        mark(stream)
        @assert read(stream, UInt8) == UInt8('b')
        BufferedStreams.fillbuffer!(stream)
        @test stream.buffer[1] == UInt8('b')

        stream = BufferedInputStream(IOBuffer("abcdefg"), 2)
        stream.immobilized = true
        @assert read(stream, UInt8) == UInt8('a')
        mark(stream)
        @assert read(stream, UInt8) == UInt8('b')
        BufferedStreams.fillbuffer!(stream)
        @test stream.buffer[2] == UInt8('b')

        stream = BufferedInputStream(IOBuffer("abcdefg"), 6)
        stream.immobilized = true
        data = Vector{UInt8}(undef, 7)
        BufferedStreams.readbytes!(stream, data, 1, 3)
        @test data[1:3] == b"abc"
        BufferedStreams.readbytes!(stream, data, 4, 7)
        @test data[4:7] == b"defg"
    end

    @testset "BufferedInputStream: shiftdata!" begin
        stream = BufferedInputStream(IOBuffer("abcdefg"), 2)
        read(stream, 1)
        @test BufferedStreams.shiftdata!(stream) > 0
        read(stream, 2)
        @test BufferedStreams.shiftdata!(stream) > 0
    end

    @testset "BufferedInputStream: misc." begin
        stream = BufferedInputStream(IOBuffer("foobar"), 10)
        @test !BufferedStreams.ensurebuffered!(stream, 10)
        repr_regex = r"^BufferedInputStream{.*}\(<.* \d+% filled>\)$"
        @test occursin(repr_regex, repr(stream))

        stream = BufferedInputStream(IOBuffer("foobar"), 4 * 2^10)
        @test occursin(repr_regex, repr(stream))
        @test occursin(r"KiB", repr(stream))

        close(stream)
        @test occursin(r"^BufferedInputStream{.*}\(<closed>\)$", repr(stream))
        @test_throws ArgumentError BufferedInputStream(IOBuffer("foo"), 0)
    end

    @testset "BufferedInputStream: massive read" begin
        byte = 0x34
        bufsize = 1024
        stream = BufferedInputStream(InfiniteStream(byte), bufsize)

        # read byte by byte
        ok = true
        for i in 1:2^30
            ok = ok && (read(stream, UInt8) == byte)
        end
        @test ok
        @test length(stream.buffer) == 1024

        # read in one shot
        @test all(read(stream, 5 * bufsize) .== byte)
        @test length(stream.buffer) == 1024
    end

    @testset "BufferedInputStream: readavailable" begin
        stream = BufferedInputStream(IOBuffer("some data"))
        @test readavailable(stream) == b"some data"
    end

    @testset "BufferedInputStream: copyuntil" begin
        # note: readlines calls readuntil which calls copyline,
        # which calls copyuntil for keep=true, in Julia 1.11
        data = join(randstring(rand(0:32))*(rand(Bool) ? "\n" : "\r\n")
                    for n=0:100) * "\n\r\n\r\r\r\r\nfooooooobar"
        for bufsize in (1, 3, 7, 128), keep in (true, false)
            s = BufferedInputStream(IOBuffer(data), bufsize)
            @test readlines(s; keep) == readlines(IOBuffer(data); keep)
        end
    end

    @testset "BufferedInputStream: read/peek/skipchars" begin
        ascii = randstring(100)
        unicode = randstring("xα∆🐨", 100) * 'β' # mix of 1/2/3/4-byte chars
        invalid = String(rand(UInt8, 100)) # contains invalid UTF-8 data
        for data in (ascii, unicode, invalid), bufsize in (1,2,4,15,1024)
            io = BufferedInputStream(IOBuffer(data), bufsize)
            @test join(collect(readeach(io, Char))) == data
        end
        for bufsize in (1,2,3,4,15)
            data = "xα∆🐨" * unicode * invalid
            io = BufferedInputStream(IOBuffer(data), bufsize)
            for c in data
                @test peek(io, Char) == peek(io, Char) == c
                @test read(io, Char) == c
            end
        end
        for bufsize in (1,2,3,4,15), c in "xα∆🐨", n in 1:5, linecomment in (nothing, '#')
            data = c^n * "#" * c^n * "\r\n" * "😄😢"
            io = BufferedInputStream(IOBuffer(data), bufsize)
            @test skipchars(==(c), io; linecomment) === io
            @test read(io, Char) == (isnothing(linecomment) ? '#' : '😄')
        end
    end
# end

# Uncommenting top-level testset makes the tests take ~100x longer
# @testset "BufferedOutputStream" begin
    @testset "BufferedOutputStream: write" begin
        data = rand(UInt8, 1000000)
        stream1 = BufferedOutputStream()
        sink = IOBuffer()
        stream2 = BufferedOutputStream(sink, 1024)
        for c in data
            write(stream1, c)
            write(stream2, c)
        end
        flush(stream1)
        flush(stream2)
        @test take!(stream1) == data
        @test take!(sink) == data
        close(stream1)
        close(stream2)
        @test !isopen(sink)
    end

    @testset "BufferedOutputStream: arrays" begin
        expected = UInt8[]
        stream1 = BufferedOutputStream()
        sink = IOBuffer()
        stream2 = BufferedOutputStream(sink, 1024)
        for _ in 1:1000
            data = rand(UInt8, rand(1:1000))
            append!(expected, data)
            write(stream1, data)
            write(stream2, data)
        end
        flush(stream1)
        flush(stream2)
        @test take!(stream1) == expected
        @test take!(sink) == expected
        close(stream1)
        close(stream2)
    end

    @testset "BufferedOutputStream: takebuf_string" begin
        data = rand('A':'z', 1000000)
        iobuf = IOBuffer()
        stream = BufferedOutputStream()
        for c in data
            write(stream, c)
            write(iobuf, c)
        end
        @test String(take!((stream))) == String(take!((iobuf)))
    end

    @testset "BufferedOutputStream: write_result" begin
        sink = IOBuffer()
        stream = BufferedOutputStream(sink, 16)
        for len in 0:10:100
            result = write(stream, repeat("x", len))
            @test result == len
        end
    end

    @testset "BufferedOutputStream: close" begin
        iobuffer = IOBuffer()
        stream = BufferedOutputStream(iobuffer)
        @test isopen(stream)
        @test isopen(iobuffer)
        write(stream, 0x00)
        close(stream)
        @test !isopen(stream)
        @test !isopen(iobuffer)
        @test_throws Exception write(stream, 0x00)
    end

    @testset "BufferedOutputStream: vector sink" begin
        sink = UInt8[]
        stream = BufferedOutputStream(sink)
        write(stream, 0x00)
        write(stream, 0x01)
        write(stream, 0x02)
        flush(stream)
        @test take!(stream) == [0x00, 0x01, 0x02]
        @test isopen(stream)
        close(stream)
        @test !isopen(stream)
        @test_throws Exception write(stream, 0x00)
    end

    @testset "BufferedOutputStream: iostream" begin
        mktemp() do path, out
            stream = BufferedOutputStream(out, 10)
            write(stream, "hello")
            @test stat(path).size == 0
            write(stream, "world")
            @test stat(path).size == 0
            write(stream, "!")
            # BufferedOutputStream buffer has run out of space,
            # but IOStream buffer has not
            @test stat(path).size == 0
            flush(stream)
            @test stat(path).size == 11
            write(stream, "...")
            @test stat(path).size == 11
            close(stream)
            @test !isopen(out)
            @test stat(path).size == 14
        end
    end

    @testset "BufferedOutputStream: position" begin
        iob = IOBuffer()
        sink = IOBuffer()
        stream = BufferedOutputStream(sink, 16)
        for len in 0:10:100
            write(stream, repeat("x", len))
            write(iob, repeat("x", len))
            @test position(stream) == position(iob)
        end
        close(stream)
        close(iob)
        @test position(stream) == position(sink) == position(iob)

        mktemp() do path, sink
            stream = BufferedOutputStream(sink, 16)
            pos = 0
            for len in 0:10:100
                write(stream, repeat("x", len))
                pos += len
                @test position(stream) == pos
            end
        end
    end

    @testset "BufferedOutputStream: misc." begin
        stream = BufferedOutputStream(IOBuffer(), 5)
        @test eof(stream)
        @test pointer(stream) == pointer(stream.buffer)
        @test occursin(r"^BufferedOutputStream{.*}\(<.* \d+% filled>\)$", string(stream))
        close(stream)
        @test occursin(r"^BufferedOutputStream{.*}\(<closed>\)$", string(stream))
        @test_throws ArgumentError BufferedOutputStream(IOBuffer(), 0)
    end
# end

module BufferedStreams

export BufferedInputStream,
       BufferedOutputStream,
       peekbytes!,
       fillbuffer!,
       isanchored,
       anchor!,
       upanchor!,
       takeanchored!

# default buffer size is 128 KiB
const default_buffer_size = 128 * 2^10

# pretty printer of data size
function _datasize(nbytes)
    if nbytes < 1024
        return string(nbytes, " B")
    end
    k = 1
    for suffix in [" KiB", " MiB", " GiB", " TiB"]
        if nbytes < 1024^(k+1)
            return string(floor(nbytes / 1024^k; digits = 1), suffix)
        end
        k += 1
    end
    return string(Compat.floor(nbytes / 1024^k, digits = 1, base = 10), " PiB")
end

include("bufferedinputstream.jl")
include("bufferedoutputstream.jl")
include("emptystream.jl")
include("io.jl")

end # module BufferedStreams

# Empty Stream
# ============

"""
`EmptyStream` is a dummy stream to allow a buffered stream to wrap an
array without additional buffering.
"""
struct EmptyStream end

Base.close(::EmptyStream) = nothing

Base.position(stream::BufferedInputStream{EmptyStream}) = stream.position - 1
Base.position(stream::BufferedOutputStream{EmptyStream}) = stream.position - 1


# Buffered input stream
# ---------------------

function BufferedInputStream(data::Vector{UInt8}, len::Integer = lastindex(data))
    return BufferedInputStream{EmptyStream}(EmptyStream(), data, 1, len, 0, false)
end

function fillbuffer!(stream::BufferedInputStream{EmptyStream})
    return 0
end

function Base.eof(stream::BufferedInputStream{EmptyStream})
    return stream.position > stream.available
end

function Base.read(stream::BufferedInputStream{EmptyStream}, ::Type{UInt8})
    checkopen(stream)
    if eof(stream)
        throw(EOFError())
    end
    byte = stream.buffer[stream.position]
    stream.position += 1
    return byte
end

function Base.seek(stream::BufferedInputStream{EmptyStream}, pos::Integer)
    checkopen(stream)
    upanchor!(stream)
    if 1 <= pos + 1 <= stream.available
        stream.position = pos + 1
    else
        throw(BoundsError)
    end
    return stream
end


# Buffered output stream
# ----------------------

function BufferedOutputStream()
    return BufferedOutputStream(Vector{UInt8}(undef, 1024))
end

function BufferedOutputStream(data::Vector{UInt8})
    return BufferedOutputStream{EmptyStream}(EmptyStream(), data, 1)
end

function flushbuffer!(stream::BufferedOutputStream{EmptyStream}, eof::Bool=false)
    if available_bytes(stream) == 0
        sz = 2 * length(stream.buffer)
        sz = sz > 0 ? nextpow(2, sz) : 0
        resize!(stream.buffer, max(sz, 16))
    end
    return
end

function Base.write(stream::BufferedOutputStream{EmptyStream}, byte::UInt8)
    checkopen(stream)
    flushbuffer!(stream)
    stream.buffer[stream.position] = byte
    stream.position += 1
    return 1
end

function Base.write(stream::BufferedOutputStream{EmptyStream}, data::Vector{UInt8})
    checkopen(stream)
    n = length(data)
    if n > available_bytes(stream)
        sz = 
        resize!(stream.buffer, nextpow(2, n + stream.position - 1))
    end
    copyto!(stream.buffer, stream.position, data, 1)
    stream.position += n
    return n
end

# Faster append for vector-backed output streams.
@inline function Base.append!(stream::BufferedOutputStream{EmptyStream},
                              data::Vector{UInt8}, start::Int, stop::Int)
    n = stop - start + 1
    if stream.position + n > length(stream.buffer)
        resize!(stream.buffer, max(n, max(1024, 2 * length(stream.buffer))))
    end
    copyto!(stream.buffer, stream.position, data, start, n)
    stream.position += n
end

function Base.take!(stream::BufferedOutputStream{EmptyStream})
    # TODO: benchmark resizing stream.buffer, returning it, and replacing it
    # with an zero-length array, which might be fast in the common case of
    # building just one array/string.
    chunk = stream.buffer[1:stream.position-1]
    stream.position = 1
    return chunk
end

function Base.empty!(stream::BufferedOutputStream{EmptyStream})
    return stream.position = 1
end

function Base.isempty(stream::BufferedOutputStream{EmptyStream})
    return stream.position == 1
end

function Base.length(stream::BufferedOutputStream{EmptyStream})
    return stream.position - 1
end

function Base.:(==)(a::BufferedOutputStream{EmptyStream}, b::BufferedOutputStream{EmptyStream})
    if a.position == b.position
        return ccall(:memcmp, Cint, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t),
                     a.buffer, b.buffer, a.position - 1) == 0
    else
        return false
    end
end

# IO
# --

function readbytes!(source::IO, buffer::AbstractArray{UInt8}, from::Int, to::Int)
    return Base.readbytes!(source, view(buffer, from:to), to - from + 1)
end

function writebytes(sink::IO, buffer::AbstractArray{UInt8}, n::Int, eof::Bool)
    return write(sink, view(buffer, 1:n))
end


# IOStream
# --------

function readbytes!(source::IOStream, buffer::AbstractArray{UInt8}, from::Int, to::Int)
    return Int(ccall(:ios_readall, UInt, (Ptr{Cvoid}, Ptr{Cvoid}, UInt), source.ios,
                     pointer(buffer, from), to - from + 1))
end

# TODO: using ios_write, but look into _os_write_all
#function Base.write(source::IOStream, buffer::Vector{UInt8}, n::Int)
#end

```@meta
CurrentModule = BufferedStreams
DocTestSetup = quote
    using BufferedStreams
end
```
# BufferedOutputStream

```julia
stream = BufferedOutputStream(open(filename, "w")) # wrap an IOStream
```

`BufferedOutputStream` is the converse to `BufferedInputStream`, wrapping a sink
type. It also works on any writable `IO` type, as well the more specific sink
interface:

```julia
writebytes(sink::T, buffer::Vector{UInt8}, n::Int, eof::Bool)
```

This function should consume the first `n` bytes of `buffer`. The `eof` argument
is used to indicate that there will be no more input to consume. It should
return the number of bytes written, which must be `n` or 0. A return value of 0
indicates data was processed but should not be evicted from the buffer.


## `BufferedOutputStream` as an alternative to `IOBuffer`

`BufferedOutputStream` can be used as a simpler and often faster alternative to
`IOBuffer` for incrementally building strings.

```julia
out = BufferedOutputStream()
print(out, "Hello")
print(out, " World")
str = String(take!(out))
```

# BufferedStreams

[![](https://img.shields.io/github/release/JuliaIO/BufferedStreams.jl.svg?style=flat-square)](https://github.com/JuliaIO/BufferedStreams.jl/releases/latest)
[![](https://img.shields.io/badge/license-MIT-green.svg?style=flat-square)](https://github.com/JuliaIO/BufferedStreams.jl/blob/master/LICENSE)
[![Build Status](https://github.com/JuliaIO/BufferedStreams.jl/workflows/CI/badge.svg)](https://github.com/JuliaIO/BufferedStreams.jl/actions?query=workflows/CI) [![codecov](https://codecov.io/gh/JuliaIO/BufferedStreams.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaIO/BufferedStreams.jl)
[![](https://img.shields.io/badge/docs-stable-blue.svg?style=flat-square)](https://juliaio.github.io/BufferedStreams.jl/stable)
[![Project Status: Inactive](https://www.repostatus.org/badges/latest/inactive.svg)](https://www.repostatus.org/#inactive)
[![Chat on Discord](https://img.shields.io/badge/discord-chat-blue.svg?style=flat-square&logo=discord&colorB=%237289DA)](https://discord.gg/z73YNFz)


## Description

BufferedStreams provides buffering for IO operations. It can wrap any IO type
automatically making incremental reading and writing faster.


## Installation

```julia
using Pkg
Pkg.add("BufferedStreams")
```

```@meta
CurrentModule = BufferedStreams
DocTestSetup = quote
    using BufferedStreams
end
```
# BufferedInputStream


```julia
BufferedInputStream(open(filename)) # wrap an IOStream
BufferedInputStream(rand(UInt8, 100)) # wrap a byte array
```

`BufferedInputStream` wraps a source. A source can be any `IO` object, but more
specifically it can be any type `T` that implements a function:
```julia
BufferedStreams.readbytes!(source::T, buffer::Vector{UInt8}, from::Int, to::Int)
```

This function should write new data to `buffer` starting at position `from` and
not exceeding position `to` and return the number of bytes written.

`BufferedInputStream` is itself an `IO` type and implements the source type so
you can use it like any other `IO` type.

Calling `close` propagates to the underlying source object if applicable; once
you wrap an `IO` object with a buffered stream, you can automatically close it
by calling `close` on the buffered stream. Hence, if you are using a source that
requires closing of an underlying system resource like file IO or socket, ensure
you implement a `close` method in your source. This may be important for
on-access locking file systems as in the MS Windows OS.

## Anchors

Input streams also have some tricks to make parsing applications easier. When
parsing data incrementally, one must take care that partial matches are
preserved across buffer refills. One easy way to do this is to copy it to a
temporary buffer, but this unecessary copying can slow things down.

Input streams instead support the notion of "anchoring", which instructs the
stream to save the current position in the buffer. If the buffer gets refilled,
then any data in the buffer including or following that position gets shifted
over to make room. When the match is finished, one can then call `takeanchored!`
return an array of the bytes from the anchored position to the currened
position, or `upanchor!` to return the index of the anchored position in the
buffer.

```julia
# print all numbers literals from a stream
stream = BufferedInputStream(source)
while !eof(stream)
    b = peek(stream)
    if '1' <= b <= '9'
        if !isanchored(stream)
            anchor!(stream)
        end
    elseif isanchored(stream)
        println(ASCIIString(takeanchored!(stream)))
    end
    read(stream, UInt8)
end
```
